/* chm2html.h
    extract html files from chm format,
    base on chmtools written by Matthew T. Russotto

    Copyright (c) 2003 by Samuel Yang <labourvanity@yahoo.com.tw>

    This program is free software;
    You can redistribute it and/or modify it under the terms of
    the GNU Lesser General Public License (version 2) as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this package; if not, contact to me.  */

// version 0.1a

#include <stdio.h>
#define PREAMBLE_LEN	0x60
#define LANG_ID		0x0409
#define LANG_ID_B5	0x0404
#define HEADER_0_LEN	0x18
#define DIR_LEN		0x54
#define LIST_OFFSET	0x14

#define CHM_ERR(x) { fputs(x"\n",stderr); return -1; }

typedef struct{
    _S32_ root;
    _S32_ first;
    _S32_ last;
    _U32_ size;
}chunks;

typedef struct{
    char *name;
    _U32_ section;
    _U32_ offset;
    _U32_ length;
}entries;

_U16_ name_list_file[]={ 30, 2, 
    12,'U','n','c','o','m','p','r','e','s','s','e','d',0,
    12,'M','S','C','o','m','p','r','e','s','s','e','d',0};

#define NAME_LIST_STR "::DataSpace/NameList"
#define CTRL_DATA_STR "::DataSpace/Storage/MSCompressed/ControlData"
#define CTRL_DATA_LEN 0x14
#define SPAN_INFO_STR "::DataSpace/Storage/MSCompressed/SpanInfo"
#define CONTENT_1_STR "::DataSpace/Storage/MSCompressed/Content"

extern unsigned short	b5_out[];
