/* datatype.c:
    A porting kit to determine the data structure of the operating system.
    This file is appeared in several package provide by Samuel Yang.

    Copyright (c) 2003 by Samuel Yang <labourvanity@yahoo.com.tw>

    This program is free software;
    You can redistribute it and/or modify it under the terms of
    the GNU Lesser General Public License (version 2) as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this package; if not, contact to me.  */

// version 2.0

#include <stdio.h>
#include <stdlib.h>

char *copying="/* datatype.h: Auto-generated by datatype.c\n\
    A porting kit to determine the data structure of the operating system.\n\
    This file is appeared in several package provide by Samuel Yang.\n\n\
    Copyright (c) 2003 by Samuel Yang <labourvanity@yahoo.com.tw>\n\n\
    This program is free software;\n\
    You can redistribute it and/or modify it under the terms of\n\
    the GNU Lesser General Public License (version 2) as published by\n\
    the Free Software Foundation.\n\n\
    This program is distributed in the hope that it will be useful,\n\
    but WITHOUT ANY WARRANTY; without even the implied warranty of\n\
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n\
    GNU General Public License for more details.\n\n\
    You should have received a copy of the GNU Lesser General Public\n\
    License along with this package; if not, contact to me.  */\n\n";

int data_type[]= {
    sizeof(char), sizeof(short), sizeof(int), sizeof(long), sizeof( long long)
};
char *type_symbol[]= {"char","short","int","long","long long"};
int type_len[]= {1,2,4,8};
int type_idx[4];

int chk_type_len( int len){
    int i;
    for( i=0; i<5; i++)
	if( data_type[i] == len)
	    return i;
    fprintf( stderr, "datatype: error code (%d)\n", len);
    return -1;
}

int main( void){
    int i;
    FILE *txt;
    for( i=0; i<4; i++)
	if( (type_idx[i]= chk_type_len( type_len[i])) < 0){
	    fputs( "datatype: can not determine data type\n", stderr);
	    return -1;
	}
    if( (txt= fopen( "datatype.h", "w")) == 0){
	fputs( "datatype: can not write file\n", stderr);
	return -1;
    }
    fputs( copying, txt);
    for( i=0; i<4; i++)
	fprintf( txt, "typedef unsigned %s _U%d_;\n",
		type_symbol[ type_idx[i]], type_len[i]*8);
    for( i=0; i<4; i++)
	fprintf( txt, "typedef %s _S%d_;\n",
		type_symbol[ type_idx[i]], type_len[i]*8);
    fclose( txt);
    return 0;
}
